import React, { Fragment, useRef, useEffect, useState } from "react";

import { BryntumTaskBoard} from "@bryntum/taskboard-react";
// import { TaskBoard, DomClassList} from "@bryntum/taskboard";
import "./App.scss";
import { Dropdown } from "antd";


const menuItems = [
  {
    key: "1",
    label: (
      <a target="_blank" rel="noopener noreferrer" href="https://www.antgroup.com">
        1st menu item
      </a>
    ),
  },
  {
    key: "2",
    label: (
      <a target="_blank" rel="noopener noreferrer" href="https://www.aliyun.com">
        2nd menu item
      </a>
    ),
  },
  {
    key: "3",
    label: (
      <a target="_blank" rel="noopener noreferrer" href="https://www.luohanacademy.com">
        3rd menu item
      </a>
    ),
  },
];

const assigneeItems = [
  {
    key: "1",
    label: (
      <a target="_blank" rel="noopener noreferrer" href="https://www.antgroup.com">
        1st menu item
      </a>
    ),
  },
  {
    key: "2",
    label: (
      <a target="_blank" rel="noopener noreferrer" href="https://www.aliyun.com">
        2nd menu item
      </a>
    ),
  },
];

// window["addAssignee"] = () => {
//   console.log("clicked");
// };

const Kanban = () => {
  const taskBoardRef = useRef(null);

  const [position, setPosition] = useState({});

  useEffect(() => {

    window['addAssignee'] = (e) => {
        console.log("abc", e);
        setPosition({ x: e.offsetX, y: e.offsetY, action: "assignee" });
      };
  
      window['taskActionMenu'] = async (e) => {
        console.log("abc", e);
        setPosition({ x: e.clientX, y: e.clientY, action: "menu" });
      };
  }, []);

  const dropDownItems = () => {
    if (position.action === "menu") {
      return menuItems;
    }
    if (position.action === "assignee") {
      return assigneeItems;
    }
    return [];
  };


  const kanbanConfig = {
    // Url for resource avatar images
    resourceImagePath: "data/TaskBoard/images/users/",

    // Experimental, transition moving cards using the editor
    useDomTransition: true,

    // Columns to display
    columns:[
		{
			"id":"Backlog",
			"text":"Backlog",
			"value":"Backlog"
		},
		{
			"id":"In Development",
			"text":"In Development",
			"value":"In Development"
		},
		{
			"id":"In Testing",
			"text":"In Testing",
			"value":"In Testing"
		},
		{
			"id":"Done",
			"text":"Done",
			"value":"Done",
			"zoomLevel":"small"
		}
	],

    // Field used to pair a task to a column
    columnField: "state",

    tasksPerRow: 1,


    headerItems: {

      text: {
        type: "template",
        template: ({ taskRecord }) =>
          // '<div class="card card-body" id="{tagId}" <tpl if="color">style="border-color:{color};"</tpl>>' +
          // '<tpl if="path"><div class="path pb-1 text-light large-only">{path}</span></div></tpl>' +
          '<div class="flexbox h-100 align-items-center py-2" style="display:flex ; align-items:center ;justify-content: center;flex-wrap: nowrap;">' +
          '<div style="flex: 1;min-width: 0px;overflow: hidden;text-overflow: ellipsis; max-height:99%;">' +
          `<a class="h6 mb-0 clickable" href={url} data-url={url} data-open="quickview" data-target="#qv-ajax">${taskRecord.data.name}</a>` +
          "</div>" +
          `<a style="justify-self:stretch;     width: 35px;
          height: 35px;
          border-radius: 50%;
          display: flex;
          align-items: center;
          justify-content: center;
          color:white;
          background: #4db7a9;"  class="large-only" 
        
           onclick="addAssignee(event)">${taskRecord.data.resourceImages[0]?.initials}</a>` +
          `<div class="large-only action fa-lg far fa-ellipsis-v" onclick="taskActionMenu(event)" style=" width: 16px; margin: 0; padding: 6px 0px; vertical-align: center; text-align: center; padding-left: 12px"></div>` +
          "</div>" +
          `<div class="large-only text-light kanban-attrs">${taskRecord.data.customAttrs}</div>` +
          "</div>",
        style: { width: "100%" },
      },
    },

    // Project using inline data
    project: {
      tasks: [
		{
			"Id":"e8e3b0d6-dd67-4ce2-8046-212993bdbc5d",
			"pk":19869,
			"name":"abc",
			"state":"In Development",
			"url":"\/tasks\/19869",
			"canDragToEndState":true,
			"tagId":"x11lnvq",
			"plannedStart":"2023-02-28T21:30:00",
			"plannedFinish":"2023-03-01T06:30:00",
			"finishDay":"1 Mar",
			"actualPercentComplete":0,
			"resourceAllocation":[
				{
					"id":138,
					"tooltip":"Ajay Singh",
					"highlight":false,
					"initials":"AS"
				}
			],
			"resourceImages":[
				{
					"id":138,
					"tooltip":"Ajay Singh",
					"highlight":false,
					"initials":"AS"
				}
			],
			"resourceEditAction":"javascript:Celoxis.showTaskAllocationPanelInRlc(19869, 'x11lnvq');",
			"asUrl":"task.Actions.wm?id=19869",
			"scheduleHealth":{
				"text":"Not Active",
				"value":"NOT_ACTIVE",
				"style":"solid",
				"tooltip":"Project is in <b>On Hold<\/b> state.",
				"cssClass":"badge-light text-light"
			},
			"customAttrs":"",
			"index":0
		},
		{
			"Id":"7539308b-af01-4fe3-8d43-d8c7e54379a4",
			"pk":19901,
			"name":"abc",
			"state":"In Testing",
			"url":"\/tasks\/19901",
			"canDragToEndState":true,
			"tagId":"xrrgg4",
			"plannedStart":"2023-02-28T21:30:00",
			"plannedFinish":"2023-03-01T06:30:00",
			"finishDay":"1 Mar",
			"actualPercentComplete":0,
			"resourceAllocation":[
				{
					"id":138,
					"tooltip":"Ajay Singh",
					"highlight":false,
					"initials":"AS"
				}
			],
			"resourceImages":[
				{
					"id":138,
					"tooltip":"Ajay Singh",
					"highlight":false,
					"initials":"AS"
				}
			],
			"resourceEditAction":"javascript:Celoxis.showTaskAllocationPanelInRlc(19901, 'xrrgg4');",
			"asUrl":"task.Actions.wm?id=19901",
			"scheduleHealth":{
				"text":"Not Active",
				"value":"NOT_ACTIVE",
				"style":"solid",
				"tooltip":"Project is in <b>On Hold<\/b> state.",
				"cssClass":"badge-light text-light"
			},
			"customAttrs":"",
			"index":1
		}],
      autoLoad: true,
    },

  };

  return (
    <Fragment>
      <BryntumTaskBoard ref={taskBoardRef} {...kanbanConfig} />
      {position.x ? (
        <Dropdown
          menu={{ items: dropDownItems() }}
          open={true}
          onOpenChange={(open) => {
            !open && setPosition({});
          }}
          trigger={["click"]}
          align={{
            // position: "relative",
            // display: "block",
            offset: [position.x, position.y],
            // zIndex: 100,
          }}
        >
          <div
          style={{
            position: "absolute",
            display: "block",
            top: `${position.y}px`,
            left: `${position.x}px`,
            zIndex: 100,
          }}
          >
            &nbsp;
          </div>
        </Dropdown>
      ) : (
        ""
      )}

      {}
    </Fragment>
  );
};

export default Kanban;